%global apiver  20090626
%global zendver 20090626
%global pdover  20080721

%define phplib %{_libdir}/php
%define extdir %{phplib}/extensions
%define peardir %{_datadir}/php/pear
%define phpvar  /var/lib/php

%define allow_nosafe_mode_exec 1
%define _unpackaged_files_terminate_build 0

# don't build debug package
%define debug_package %{nil}
# don't binary strip
#define __spec_install_post %{nil}

%define build_fpm 1

%{!?_with_no_goto:%define _vm_goto 1}
%{?_with_no_goto:%define _vm_goto 0}

Summary: The PHP HTML-embedded scripting language for use with Apache2.
Summary(ko): Apache2 PHP 엔진
Name: php
Version: 5.3.27
Release: 2%{?dist}
Epoch: 1
Group: Development/Languages
License: PHP
Source0: http://www.php.net/distributions/php-%{version}.tar.bz2
Source2: info.php
Source3: macros.php
Source4: php-dependency.txt

Source100: pecl-extension.tar.bz2
Source101: httpd.conf
Source102: annyung_func_alias_table.php

# patch start

# security
Patch6000: php-5.3.27-CVE-2013-4073.patch

Patch9000: php-5.3.1-unofficial-bug-51056-fread.patch

# oops patch to 1 - 99
Patch1: php-ini.patch
Patch2: php-version.patch
Patch3: php-libtool2.patch

# extension patch
Patch20: php-mysql.patch
Patch21: php-mysql-charset.patch
Patch22: php-gd-charspace.patch
Patch23: php-libgd-freetype.patch
Patch24: php-annyung-nosafe-exec-dir.patch
Patch25: php-sqlite-config.patch
Patch26: php-dba.patch
Patch27: php-snmp-shutdown.patch
Patch28: php-5.3.1-openssl096.patch
Patch29: php-phpize64.patch
Patch30: php-includedir.patch
Patch31: php-tmpdir.patch
Patch32: php-annyung-alias.patch
Patch33: php-annyung-zend-listed-table.patch
# Patch 34 and Patch 35 are dependent on patch 33
Patch34: php-annyung-include-file-check.patch
# Patch 35 is dependent on Patch 34
Patch35: php-annyung-image-attack.patch
# block '\0' to path after 5.3.4RC1. still need?
Patch36: php-annyung-urldecode-hex-null.patch
Patch37: php-annyung-always-short-tag-with-echo.patch
Patch38: php-annyung-realpath-cache-force.patch
Patch39: php-annyung-ldap-pagenation.patch
Patch40: php-5.3.26-fpm-logpath.patch

# patch for rhel5
Patch100: php-4.3.1-odbc.patch
Patch101: php-fc-dlopen.patch
Patch102: php-5.3.18-aconf26x.patch
Patch103: php-5.3.18-gnusrc.patch
Patch104: php-5.3.18-systzdata-v7.patch
Patch105: php-5.3.18-embed.patch

# patch third party extension
Patch202: php-ncurses-5.3.patch
Patch203: php-libevent-1.4.patch

# private patch
# http://wiki.ohgaki.net/index.php?PHP%2Fpatch
Patch3000: php-allow_url_fopen-INI_ALL.patch

# offcial patch
#Patch5000: php-5.3.26-official-b53437.patch

# security


# patch end
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Requires: webserver, php-common, libicu, bzip2-libs
Requires: openssl, zlib
BuildRequires: readline-devel, ncurses-devel, zlib-devel, file >= 4
BuildRequires: libpng-devel, libjpeg-devel, db4-devel, gdbm-devel
#BuildRequires: openssl-devel, zlib-devel, libxml2-devel, mysql-devel
BuildRequires: openssl-devel, zlib-devel, libxml2-devel bison
BuildRequires: curl-devel, freetds-devel, freetype-devel
BuildRequires: libmcrypt-devel, mhash-devel, libicu-devel
BuildRequires: libevent-devel >= 1.4, net-snmp-devel sqlite-devel
BuildRequires: httpd-devel, sendmail, openldap-devel bzip2-devel
Provides: phpapi
Obsoletes: php-intl php-pdo php-xmlrpc php-mbstring

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial
and non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most
common use of PHP coding is probably as a replacement for CGI
scripts.  The mod_php module enables the Apache web server to
understand and process the embedded PHP language in web pages.

Building option:
	--with no_goto : if don't add vm kind option with goto..

%package cli
Group: Development/Languages
Summary: php command line interface
Summary(ko): php cli 인터페이스
Requires: php-common, readline, ncurses, zlib, openssl, libicu
Provides: phpapi
Obsoletes: php-intl php-pdo php-xmlrpc php-mbstring

%description cli
php binary file to use in shell

%package fpm
Group: Development/Languages
Summary: php5 fastcgi
Requires: php-fpm-conf, zlib, openssl, libicu, ncurses, libicu
Provides: phpapi
Obsoletes: php-intl php-pdo php-xmlrpc php-mbstring

%description fpm
php fastcgi package

%package devel
Group: Development/Libraries
Summary: php development file for making extensions
Summary: php 확장 개발을 위한 파일들

%description devel
php build file for making extensions

%package extension
Group: Development/Languages
Summary: php shared extension
Requires: phpapi
Requires: libjpeg, db4, gdbm, file, curl, openldap
#Requires: sqlite, mysql-shared, freetype, freetds, libpng, libmcrypt, mhash
Requires: sqlite, freetype, freetds, libpng, libmcrypt, mhash
Requires: libicu, libevent >= 1.4, net-snmp-libs
# block centos' php
Obsoletes: php-bcmath php-dba php-gd php-imap php-ldap php-odbc
Obsoletes: php-mysql php-pecl-apc php-pecl-memcache php-pgsql
Obsoletes: php-recode php-snmp php-soap php-tidy php-xml

%description extension
This package include php shared extension

%prep
%setup -q -n php-%{version} -a 100

pushd $RPM_BUILD_DIR/php-%{version} &> /dev/null
tar xvfpj %{SOURCE100}
popd &> /dev/null

# official patch


# sec patch
%patch6000 -p1

# AnNyugn patch
%patch9000 -p1

%patch1 -p1
%patch2 -p1
%patch3 -p1

%patch20 -p1
#patch21 -p1
%patch22 -p1
%patch23 -p1
%if %{allow_nosafe_mode_exec}
%patch24 -p1
%endif
%patch25 -p1
%patch26 -p1
%patch27 -p1
#patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
#patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%if %{build_fpm}
%patch40 -p1
%endif

# fedora patch
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1

# private update
%patch3000 -p1

#patch202 -p0
#patch203 -p0


%if %{_vm_goto}
pushd Zend
	# php 5.3 support --with-zend-vm=GOTO. is applicated readly?
	if [ -f "/usr/bin/php" ]; then
		%{__rm} -f zend_vm_execute.h
		php zend_vm_gen.php --with-vm-kind=GOTO
	fi
popd
%endif

%build

BuildPHP() {
	[ ! -d "%{phpvar}/tmp" ] && mkdir -p %{phpvar}/tmp && chmod 1777 %{phpvar}/tmp
	#OOPS_FLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing -Wno-pointer-sign"
	RPMS_FLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing"
	export CFLAGS="-fPIC ${RPMS_FLAGS}"
	export EXTENSION_DIR=%{extdir}
	export PEAR_INSTALLDIR=%{peardir}

	case "$1" in
		cli) scandir="cli"; shift ;;
		apache) scandir="apache"; shift ;;
		fpm) scandir="fpm"; shift ;;
	esac

#		--without-pic \
	%{configure} \
		--with-libdir=%{_lib} \
		--sysconfdir=%{_sysconfdir}/php.d \
		--with-config-file-path=%{_sysconfdir}/php.d \
		--with-config-file-scan-dir=%{_sysconfdir}/php.d/$scandir \
		--disable-debug \
		--disable-xmlreader \
		--disable-xmlwriter \
		--disable-json \
		--without-pear \
		--without-sqlite \
		--without-sqlite3 \
		--with-regex=php \
		--with-bz2 \
		--with-zlib \
		--with-zlib-dir=%{_prefix} \
		--enable-mod-charset \
		--enable-zend-multibyte \
		--enable-sigchild \
		--enable-safe-mode \
		--enable-inline-optimization \
		--enable-magic-quotes \
		--enable-sysvsem \
		--enable-sysvshm \
		--enable-sysvmsg \
		--enable-intl \
		--enable-libxml \
		--enable-soap=shared \
		--enable-hash \
		--enable-pdo \
		--without-pdo-sqlite \
		--without-pdo-mysql \
		--enable-sockets \
		--enable-mbstring=all \
		--enable-mbregex \
		--enable-mbregex-backtrack \
		--with-libmbfl \
		--with-iconv \
		--with-openssl \
		--with-xmlrpc \
		--with-mysql=shared,mysqlnd \
		--with-system-tzdata \
		$*

	%{__make} %{?_smp_mflags}
}

%{__rm} -f configure

# aclocal workaround - to be improved
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >>aclocal.m4

# pull latest ltmain.sh, AC_PROG_LIBTOOL
# Force use of system libtool:
libtoolize --force --copy
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >build/libtool.m4
# force aclocal run during buildconf
touch acinclude.m4

./buildconf --force

# binary compile
BuildPHP cli \
		--with-exec-dir="" \
		--enable-phar \
		--enable-pcntl \
		--with-readline \
		--with-ncurses \
		--disable-cgi \
		--enable-static

mv sapi/cli/php sapi/cli/php-cli
%{__mkdir_p} %{buildroot}%{_bindir}
mv ext/phar/phar.phar ext/phar/phar.phar.cli

# build fastcgi module
%{__make} clean

%if %{build_fpm}
BuildPHP fpm \
		--with-exec-dir=%{phpvar}/bin \
		--disable-cli \
		--enable-fpm \
		--enable-pcntl \
		--with-ncurses

mv sapi/fpm/php-fpm sapi/fpm/php-fpm-back

# build apache module
%{__make} clean
%endif

BuildPHP apache \
		--with-apxs2=/usr/sbin/apxs \
		--with-exec-dir=%{phpvar}/bin \
		--disable-cli \
		--disable-cgi \
		--with-curl=shared,%{_prefix} \
		--with-gd=shared \
		--enable-gd-native-ttf \
		--with-jpeg-dir=%{_prefix} \
		--with-png-dir=%{_prefix} \
		--with-freetype-dir=%{_prefix} \
		--enable-bcmath=shared \
		--enable-calendar=shared \
		--enable-memcache=shared \
		--enable-xmlreader=shared, --enable-xmlwriter=shared \
		--enable-ftp=shared \
		--enable-dba=shared \
		--enable-exif=shared \
		--with-gdbm \
		--with-dbm \
		--with-db4 \
		--enable-fileinfo=shared \
		--with-gettext=shared \
		--with-mcrypt=shared \
		--with-sqlite3=shared \
		--with-sqlite=shared --enable-sqlite-utf8 \
		--with-ldap=shared --with-ldap-sasl \
		--with-snmp=shared,%{_prefix} \
		--with-libevent=shared \
		--with-pdo-sqlite=shared,%{_prefix} \
		--with-pdo-mysql=shared,mysqlnd \
		--with-mysqli=shared,mysqlnd \
		--with-mssql=shared \
		--enable-json=shared

cd modules
/bin/ls *.so | sed 's/^/;extension = /' > ../extensions.ini
cd -

%install
[ "%{buildroot}" != "/" -a -d "${buildroot}" ] && rm -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_sysconfdir}/httpd/conf
install -m644 %{SOURCE101} %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf

%{__make} install INSTALL_ROOT=%{buildroot} INSTALL_ID="echo "

rm -rf %{buildroot}%{extdir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{extdir}
mkdir -p %{buildroot}/home/httpd/html
mkdir -p %{buildroot}%{_mandir}/{man1,man8}
mkdir -p %{buildroot}%{_sysconfdir}/php.d/{cli,apache}

install -m 755 ext/phar/phar.phar.cli %{buildroot}%{_bindir}/phar.phar
cd %{buildroot}%{_bindir}
ln -sf phar.phar phar
cd -

install -m 755 sapi/cli/php-cli %{buildroot}%{_bindir}/php
install -m 644 sapi/cli/php.1 %{buildroot}%{_mandir}/man1/php.1
#(cd %{buildroot}%{_bindir}; ln -sf php php5)
install -m 755 -s modules/*.so %{buildroot}%{extdir}
install -m 644 php.ini-production %{buildroot}%{_sysconfdir}/php.d/php.ini
install -m 644 php.ini-production %{buildroot}%{_sysconfdir}/php.d/php-cli.ini
install -m 644 %{SOURCE2} %{buildroot}/home/httpd/html/php_info.php

install -m 644 extensions.ini %{buildroot}%{_sysconfdir}/php.d/apache/shared.ini
install -m 644 extensions.ini %{buildroot}%{_sysconfdir}/php.d/cli/shared.ini


%if %{build_fpm}
%{__mkdir_p} %{buildroot}%{_sbindir}
install -m 755 sapi/fpm/php-fpm-back %{buildroot}%{_sbindir}/php-fpm
install -m 644 sapi/fpm/php-fpm.8  %{buildroot}%{_mandir}/man8/php-fpm.8
%endif

%{__mkdir_p} %{buildroot}%{peardir}
install -m 644 %{SOURCE102} %{buildroot}/%{peardir}/alias_table.php

mv LICENSE LICENSE.php5

# session and update tmp dir
mkdir -p %{buildroot}%{phpvar}/{sessions,tmp,bin}

# dependency problem
pushd %{buildroot}%{phplib}/build
	chmod 644 *
	chmod 755 shtool
popd

# Generate files lists and stub .ini files for each subpackage
for mod in $(ls %{buildroot}%{extdir}/*.so)
do
	modname=$(basename $mod | sed 's/\.so//g')
	cat >> files.ext <<EOF
%attr(755,root,root) %{extdir}/${modname}.so
EOF
done

# Package pdo_sqlite with pdo; isolating the sqlite dependency
# isn't useful at this time since rpm itself requires sqlite.
#cat files.pdo_sqlite >> files.pdo

# Install the macros file:
install -d %{buildroot}%{_sysconfdir}/rpm
sed -e "s/@PHP_APIVER@/%{apiver}/;s/@PHP_ZENDVER@/%{zendver}/;s/@PHP_PDOVER@/%{pdover}/" \
    < $RPM_SOURCE_DIR/macros.php > macros.php
install -m 644 -c macros.php \
           %{buildroot}%{_sysconfdir}/rpm/macros.php

# Remove unpackaged files
rm -rf %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf \
       %{buildroot}%{_bindir}/{phptar} \
       %{buildroot}%{_datadir}/pear

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
rm -f files.* macros.php

%files
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/httpd/modules/libphp5.so
#{peardir}/alias_table.php
%dir %{phplib}
%dir %{phplib}/extensions
%attr(755,nobody,nobody) %dir %{phpvar}/sessions
%attr(1777,root,root) %dir %{phpvar}/tmp
%attr(755,root,root) %dir %{phpvar}/bin

%files cli
%defattr(-,root,root)
%attr(755,root,root) %{_bindir}/php
%attr(755,root,root) %{_bindir}/phar.phar
%{_bindir}/phar
%{_mandir}/man1/php.1*
#{_bindir}/php5

%if %{build_fpm}
%files fpm
%defattr(-,root,root)
%attr(755,root,root) %{_sbindir}/php-fpm
%{_mandir}/man8/php-fpm.8*
%endif

%files devel
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/rpm/macros.php
%{_bindir}/php-config
%{_bindir}/phpize
%{_includedir}/php
%{_libdir}/php/build

%files extension -f files.ext

%changelog
* Mon Aug 26 2013 JoungKyun.Kim <http://oops.org> 1:5.3.27-2%{?dist}
- security issues
  . CVE-2013-4073 Fixed handling null bytes in subjectAltName


* Fri Jul 12 2013 JoungKyun.Kim <http://oops.org> 1:5.3.27-1%{?dist}
- update 5.3.27

- security issues
  . CVE-2013-4113 #65236 heap corruption in xml parser

* Fri Jun 21 2013 JoungKyun.Kim <http://oops.org> 1:5.3.26-1%{?dist}
- update 5.3.26
- update pecl libevent extension 0.1.0
- update pecl ncurses extension 1.0.2

- Official bug fix
  . #53437 Crash when using unserialized DatePeriod instance
  . #64949 Buffer overflow in _pdo_pgsql_error.
  . #64609 pg_convert enum type support.
  . #64960 Segfault in gc_zval_possible_root.
  . #64934 Apache2 TS crash with get_browser()
  . #64966 segfault in zend_do_fcall_common_helper_SPEC
  . #64997 Segfault while using RecursiveIteratorIterator on 64-bits systems

- security issues
  . CVE 2013-2110 Heap based buffer overflow in quoted_printable_encode (#64879)

* Fri Jan  1 2013 JoungKyun.Kim <http://oops.org> 1:5.3.18-3%{?dist}
- add ldap pagenation patch from PHP 5.4
- build fpm sapi

* Thu Nov 15 2012 JoungKyun.Kim <http://oops.org> 1:5.3.18-2%{?dist}
- Fixed bug #62593 Emulate prepares behave strangely with PARAM_BOOL
- Fixed bug #63447 max_input_vars doesn't filter variables when
  mbstring.encoding_translation = On
- set realpath_cache_force to enable, force enable realpath_cache_size
  and realpath_cache_ttl although safe_mode or open_basedir set enabled.

* Tue Oct 30 2012 JoungKyun.Kim <http://oops.org> 1:5.3.18-1%{?dist}
- update 5.3.18
- Always support short tag with echo '<?='
- pecl memcache update to 2.2.7
- pecl libevent update to 0.0.5
- support system tz data option
- Fixed bug #63297 (Phar fails to write an openssl based signature).
- Fixed bug #63240 (stream_get_line() return contains delimiter string).
- Fixed bug #63235 (buffer overflow in use of SQLGetDiagRec).
- Fixed bug #63284 (Upgrade PCRE to 8.31).
- Fixed bug #63055 (Segfault in zend_gc with SF2 testsuite).
- Fixed bug #63265 (Add ORA-00028 to the PHP_OCI_HANDLE_ERROR macro)
- Fixed compilation failure on mixed 32/64 bit systems.
- Fixed bug #63389 (Missing context check on libxml_set_streams_context()
  causes memleak).

* Fri Oct 12 2012 JoungKyun.Kim <http://oops.org> 1:5.3.5-10%{?dist}
- fixed wrong configure option

* Fri Sep  7 2012 JoungKyun.Kim <http://oops.org> 1:5.3.5-9%{?dist}
- fixed CVE-2012-1823
- fixed CVE-2012-2143
- fixed CVE-2012-2688
- fixed CVE-2012-3365
- fixed bug 61948 CURLOPT_COOKIFILE '' raises open_basedir restriction
- fixed bug 62885 mysqli_poll - Segmentation fault
- fixed bug 61367 open_basedir bypass using libxml RSHUTDOWN
                  Add open_basedir checks to readline_write_history and readline_read_history
                  open_basedir check for linkinfo

* Sun Jul  1 2012 JoungKyun.Kim <http://oops.org> 1:5.3.5-8%{?dist}
- fixed CVE-2012-1172
- fixed CVE-2012-0831

* Sun Feb 26 2012 JoungKyun.Kim <http://oops.org> 1:5.3.5-7%{?dist}
- add record, snmp, ldap, xml extension
- rename php-binary to php-cli

* Sat Feb  4 2012 JoungKyun.Kim <http://oops.org> 1:5.3.5-6%{?dist}
- fixed CVE-2012-0830

* Thu Jan  5 2012 JoungKyun.Kim <http://oops.org> 1:5.3.5-5%{?dist}
- fixed CVE-2011-4885
- fixed CVE-2011-1466
- fixed CVE-2011-1468
- fixed CVE-2011-1469
- fixed CVE-2011-2483

* Wed Jul  6 2011 JoungKyun.Kim <http://oops.org> 1:5.3.5-4%{?dist}
- fixed CVE-2011-2202 (bug #54939)
- fixed CVE-2011-1148 (bug #54238)
- fixed official patch
  . stream_get_contents infinite loop (bug #54946)
  . Segfault when when writing to a persistent socket after
    closing a copy of the socket (bug #54263)

* Tue Jun 21 2011 JoungKyun.Kim <http://oops.org> 1:5.3.5-3%{?dist}
- fixed CVE-2011-1938
- fixed CVE-2011-0421 (bug #53885)
- fixed CVE-2011-0708 (bug #54002)
- fixed CVE-2011-1153 (bug #45247)
- fixed CVE-2011-1092 (bug #54193)

* Mon Mar 14 2011 JoungKyun.Kim <http://oops.org> 1:5.3.5-2%{?dist}
- refixed fread problem (bug: 51056) - still don't fix yet.

* Fri Jan 21 2011 JoungKyun.Kim <http://oops.org> 1:5.3.5-1%{?dist}
- fixed CVE-2010-4645
- fixed official patch
  . Fixed bug #39199 (Cannot load Lob data with more than 4000 bytes on ORACLE 10)
  . Fixed bug #53512 (NumberFormatter::setSymbol crash on bogus $attr values)
  . MFH: Fix indirect reference of $this
  . Fixed bug #53517 (segfault in pgsql_stmt_execute() when postgres is down)
  . Fixed bug #53515 (property_exists incorrect on ArrayObject null and 0 values)
  . Implemented request #26158/bug #53465 (open arbitrary file descriptor with fopen)
  . Fixed parameter check introduced with the recent fix for bug #53492.
  . Fixed bug #53502 (mysqli::query returns false after successful LOAD DATA query)
  . Fixed bug #53425 (mysqli_real_connect() ignores client flags when built to
    call libmysql)
  . Fixed bug #53150 (FILTER_FLAG_NO_RES_RANGE is missing some IP ranges)
  . Fixed bug 48484 (array_product() always returns 0 for an empty array).
  . Fixed bug #47435 (FILTER_FLAG_NO_RES_RANGE don't work with ipv6).
  . Fixed bug #53529 (php_crypt tests gcc version incorrectly due to
    typo) (vapier at gmail dot com)
  . MFH: implement FR #53447 (Cannot disable SessionTicket extension for servers
    that do not support it). Includes Tony's subsequent commit to fix a segfault.
  . MFH: fixed bug #53377 (imap_mime_header_decode() doesn't ignore \t during long
    MIME header unfolding).
  . Fixed bug #53493 (xmlrpc_decode should not be sensitive to leading whitespace)
  . Revert fix for bug #53493 to be compliant with the XML specification
  . Fixed bug #48607 (fwrite() doesn't check reply from ftp server before exiting)
  . Fixed bug #53541 (format string bug in ext/phar).
  . mysqlnd:
    count preciser in case of error.
    fix a small bug about affected_rows in the text protocol
  .date:
    Fixed a bug in DateTime->modify() where absolute date/time statements had
    no effect.
  . Fixed bug #53568 (swapped memset arguments in struct initialization).
  . Fixed bug #53527 (php-fpm --test doesn't set a valuable return value).
  . fix leak introduced by the null poisoning patch
  . intl: Fix bad args to grapheme_extract(), reported
  . Fixed bug #53574 (Integer overflow in SdnToJulian, sometimes leading to
    segfault). CVE-2011-1466
  . Fixed bug#53579 (stream_get_contents() segfaults on ziparchive streams)
    Also added the filename being access to the stream_get_meta_data() array
    CVE-2011-1470
  . Fixed bug #52209 (INPUT_ENV returns NULL for set variables (CLI)).
  . Fixed bug #53592 (stream_socket_enable_crypto() busy-waits in client mode).
  . Fixed stream_socket_enable_crypto() not honoring the socket timeout in
    server mode.
  . Fixed bug #53603 (ZipArchive should quiet stat errors).
  . Fixed bug #53612 (Segmentation fault when using several cloned intl
    objects).
  . simplexml: fix crash with entity declarations
  . Do not violate php_stream abstraction and use php_stream_tell instead
    of accessing the field .position.
  . Fixed Bug #53629 (memory leak inside highlight_string()).
  . sqlite3:
    Fix error with initialisation flag being set too early. If encryption
    is enabled and fails to decrypt a crash can occur.
    Implemented FR #53466 (SQLite3Result::columnType() should return false
    after all of the rows have been fetched).
    Fixed memory leak on SQLite3Result and SQLite3Stmt when assigning to
    a reference.
  . fix possible NULL deref
  . Fixed bug #53630 (Fixed parameter handling inside readline() function).
  . Added missing success check around chmod() for windows during temp file creation
  . Fixed bug #53729 (DatePeriod fails to initialize recurrences on 64bit
    big-endian systems).
  . Fixed bug #53717 (checking the number of arguments is wrong in
    zend_parse_method_parameters_ex())
  . add missing dl() function to FPM SAPI
  . Fix #53551 (PDOStatement execute segfaults for pdo_mysql driver)
  . Fix bug #47143, bug #51458 - provide more useful info in bad exception cases
  . Implemented FR #39771 (Made DOMDocument::saveHTML accept an optional
    DOMNode like DOMDocument::saveXML).
  . Added checks for malformated FastCGI requests (Edgar Frank)
  . iniconf: path len check and fix buffer overrun
  . gd: malloc may fail
- update memcache exntesion 2.2.6
- update safe_mode_exec_dir patch
  . adjusted missing pcntl_open api
  . block null byte character in command or command line arguments.

* Wed Jul 14 2010 JoungKyun.Kim <http://oops.org> 1:5.3.1-4%{?dist}
- fixed mysqlnd link on cli/fcgi

* Thu Jul  8 2010 JoungKyun.Kim <http://oops.org> 1:5.3.1-3%{?dist}
- fixed CVE-2010-0397
- fixed CVE-2010-2225
- donwgrade memcache extension 2.2.5 (latest stable version)
- update libevent extension 0.0.4
- add vpl r11
- build with mysqlnd library for mysql, mysqli, pdo_mysql
- fixed official bug
  Fixed bug #44098 imap_utf8() returns only capital letters
  Fixed bug #44827 define() allows :: in constant names
  Fixed bug #45599 strip_tags() truncates rest of string with
                   invalid attribute
  Fixed bug #46478 htmlentities() uses obsolete mapping table for
                   character entity references
  Fixed bug #47281 $php_errormsg is limited in size of characters
  Fixed bug #47409 extract() problem with array containing word "this"
  Fixed bug #48190 Content-type parameter "boundary" is not case-insensitive
                   in HTTP uploads
  Fixed bug #48590 (SoapClient does not honor max_redirects).
  Fixed bug #48811 Directives in PATH section do not get applied to
                   subdirectories
  Fixed bug #49174 crash when extending PDOStatement and trying to set
                   queryString property
  Fixed bug #49463 setAttributeNS fails setting default namespace
  Fixed bug #49560 oci8: using LOBs causes slow PHP shutdown
  Fixed bug #49585 date_format buffer not long enough for >4 digit years
  Fixed bug #49600 imageTTFText text shifted right
  Fixed bug #49866 Making reference on string offsets crashes PHP
  Fixed bug #50196 stream_copy_to_stream() produces warning when
                   source is not file
  Fixed bug #50392 date_create_from_format() enforces 6 digits for 'u'
                   format character
  Fixed bug #50394 Reference argument converted to value in __call
  Fixed bug #50416 PROCEDURE db.myproc can't return a result set in the
                   given context
  Fixed bug #50445 PDO-ODBC stored procedure call from Solaris 64-bit
                   causes seg fault
  Fixed bug #50458 PDO::FETCH_FUNC fails with Closures
  Fixed bug #50464 declare encoding doesn't work within an included file
  Fixed bug #50519 segfault in garbage collection when using
                   set_error_handler and DomDocument
  Fixed bug #50723 Bug in garbage collector causes crash
  Fixed bug #50728 All PDOExceptions hardcode 'code' property to 0
  Fixed bug #50732 exec() adds single byte twice to $output array
  Fixed bug #50756 CURLOPT_FTP_SKIP_PASV_IP does not exist
  Fixed bug #50761 (system.multiCall crashes in xmlrpc extension).
  Fixed bug #50787 (stream_set_write_buffer() has no effect on socket streams).
  Fixed bug #50832 (HTTP fopen wrapper does not support passwordless HTTP authentication).
  Fixed bug #50829 (php.ini directive pdo_mysql.default_socket is ignored).
  Fixed bug #50847 (strip_tags() removes all tags greater then 1023 bytes long).
  Fixed bug #50907 (X-PHP-Originating-Script adding two new lines in *NIX).
  Fixed bug #50930 (Wrong date by php_date.c patch with ancient gcc/glibc versions).
  Fixed bug #50940 (Custom content-length set incorrectly in Apache SAPIs).
  Fixed bug #50952 (allow underscore _ in constants parsed in php.ini files).
  Fixed bug #51604 newline in end of header is shown in start of message
  Fixed bug #35673 formatOutput does not work with saveHTML

* Mon Feb 22 2010 JoungKyun.Kim <http://oops.org> 0:5.3.1-2%{?dist}
- fixed fread problem (bug: 51056)

* Wed Dec  9 2009 JoungKyun.Kim <http://oops.org> 0:5.3.1-1%{?dist}
- update 5.3.1
- update sqlite3 imbeded library to 3.6.20
- NEWS 61151 protect http_session_vars from interrupt corruption
- fixed official bug
  Fixex bug #49868 As far as I can tell this was a copy-paste induced bug when
                   I added the reset_signals flag to zend_set_timeout.
  Fixed bug #49935 (Deprecated warnings make "make test" to fail)
  Fixed bug #50231 (Socket path passed using --with-mysql-sock is ignored when
                   mysqlnd is enabled)
  Fixed bug #50240 (pdo_mysql.default_socket in php.ini shouldn't used if it is
                   empty).
  Fixed bug #50267 (get_browser(null) does not use HTTP_USER_AGENT)
  Fixed bug #50323 (Allow use of ; in values via ;; in PDO DSN even in the
                   middle of a string). 
  Fixed bug #50340 (php.ini parser does not allow spaces in ini keys)
  Fixed bug #50345 (nanosleep not detected properly on some solaris versions)
  Fixed bug #50023 (pdo_mysql doesn't use PHP_MYSQL_UNIX_SOCK_ADDR)
  Fixed bug #34852 (Failure in odbc_exec() using oracle-supplied odbc driver).
  Fixed bug #45120 (PDOStatement->execute() returns true then false for same
                   statement).
  Fixed bug #47848 (importNode doesn't preserve attribute namespaces).
  Fixed bug #49224 (Compile error due to old DNS functions on AIX systems).
  Fixed bug #49244 (Floating point NaN cause garbage characters).
  Fixed bug #49472 (Constants defined in Interfaces can be overridden).
  Fixed bug #49521 (PDO fetchObject sets values before calling constructor).
  Fixed bug #49660 (libxml 2.7.3+ limits text nodes to 10MB). (Felipe)
  Added LIBXML_PARSEHUGE constant to overrides the maximum text size of a
  single text node when using libxml2.7.3+.
  Fixed bug #49677 (ini parser crashes with apache2 and using ${something} ini
                   variables) 
  Fixed bug #49719 (ReflectionClass::hasProperty returns true for a private
                   property in base class)
  Fixed bug #49800 (SimpleXML allow (un)serialize() calls without warning).
  Fixed bug #49921 (Curl post upload functions changed).
  Fixed bug #49936 (crash with ftp stream in php_stream_context_get_option())
  Fixed bug #49938 (Phar::isBuffering() returns inverted value).
  Fixed bug #49851 (http wrapper breaks on 1024 char long headers).
  Fixed bug #49985 (pdo_pgsql prepare() re-use previous aborted transaction).
  Fixed bug #49990 (SNMP3 warning message about security level printed twice).
  Fixed bug #50005 (Throwing through Reflection modified Exception object makes
                   segmentation fault)
  Fixed bug #50073 (parse_url() incorrect when ? in fragment).
  Fixed bug #50145 (crash while running bug35634.phpt)
  Fixed bug #50146 (property_exists: Closure object cannot have properties)
  Fixed bug #50152 (ReflectionClass::hasProperty hehaves like isset() not
                   property_exists) [5_2 is OK]
  Fixed bug #50158 (FILTER_VALIDATE_EMAIL fails with valid addresses containing
                   = or ?).
  Fixed bug #50159 (wrong working directory in symlinked files).
  Fixed bug #50168 (FastCGI fails with wrong error on HEAD request to
                   non-existant file)
  Fixed bug #50174 (Incorrectly matched docComment)
  Fixed bug #50185 (ldap_get_entries() return false instead of an empty array
                   when there is no error).
  Fixed bug #50195 (pg_copy_to() fails when table name contains schema).
  Fixed bug #50207 (segmentation fault when concatenating very large strings on
                   64bit linux).
  Fixed bug #50212 (crash by ldap_get_option() with LDAP_OPT_NETWORK_TIMEOUT).
  Fixed bug #50219 (soap call Segmentation fault on a redirected url).
  Fixed bug #50255 (isset() and empty() silently casts array to object)
  Fixed bug #50261 (Crash When Calling Parent Constructor with call_user_func())
  Fixed bug #50266 (conflicting types for llabs)
  Fixed bug #50282 (xmlrpc_encode_request() changes object into array in calling
                   function)
  Fixed bug #50285 (xmlrpc does not preserve keys in encoded indexed arrays)
  Fixed bug #50351 (performance regression handling objects, ten times slower in
                   5.3 than in 5.2. foreach statement should not initiate GC)
  proper fix for bug #50006 add modify protection to all user array sorts

